VTK: vtkCommand Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
vtkCommand Class Referenceabstract

superclass for callback/observer methods More...

`#include <vtkCommand.h>`

Inheritance diagram for vtkCommand:
[legend]
Collaboration diagram for vtkCommand:
[legend]

## Public Types
enum | EventIds { NoEvent = 0 , AnyEvent , DeleteEvent , StartEvent , EndEvent , RenderEvent , ProgressEvent , PickEvent , StartPickEvent , EndPickEvent , AbortCheckEvent , ExitEvent , LeftButtonPressEvent , LeftButtonReleaseEvent , MiddleButtonPressEvent , MiddleButtonReleaseEvent , RightButtonPressEvent , RightButtonReleaseEvent , EnterEvent , LeaveEvent , KeyPressEvent , KeyReleaseEvent , CharEvent , ExposeEvent , ConfigureEvent , TimerEvent , MouseMoveEvent , MouseWheelForwardEvent , MouseWheelBackwardEvent , ActiveCameraEvent , CreateCameraEvent , ResetCameraEvent , ResetCameraClippingRangeEvent , ModifiedEvent , WindowLevelEvent , StartWindowLevelEvent , EndWindowLevelEvent , ResetWindowLevelEvent , SetOutputEvent , ErrorEvent , WarningEvent , StartInteractionEvent , DropFilesEvent , UpdateDropLocationEvent , InteractionEvent , EndInteractionEvent , EnableEvent , DisableEvent , CreateTimerEvent , DestroyTimerEvent , PlacePointEvent , DeletePointEvent , PlaceWidgetEvent , CursorChangedEvent , ExecuteInformationEvent , RenderWindowMessageEvent , WrongTagEvent , StartAnimationCueEvent , ResliceAxesChangedEvent , AnimationCueTickEvent , EndAnimationCueEvent , VolumeMapperRenderEndEvent , VolumeMapperRenderProgressEvent , VolumeMapperRenderStartEvent , VolumeMapperComputeGradientsEndEvent , VolumeMapperComputeGradientsProgressEvent , VolumeMapperComputeGradientsStartEvent , WidgetModifiedEvent , WidgetValueChangedEvent , WidgetActivateEvent , ConnectionCreatedEvent , ConnectionClosedEvent , DomainModifiedEvent , PropertyModifiedEvent , UpdateEvent , RegisterEvent , UnRegisterEvent , UpdateInformationEvent , AnnotationChangedEvent , SelectionChangedEvent , UpdatePropertyEvent , ViewProgressEvent , UpdateDataEvent , CurrentChangedEvent , ComputeVisiblePropBoundsEvent , TDxMotionEvent , TDxButtonPressEvent , TDxButtonReleaseEvent , HoverEvent , LoadStateEvent , SaveStateEvent , StateChangedEvent , WindowMakeCurrentEvent , WindowIsCurrentEvent , WindowFrameEvent , HighlightEvent , WindowSupportsOpenGLEvent , WindowIsDirectEvent , WindowStereoTypeChangedEvent , WindowResizeEvent , UncheckedPropertyModifiedEvent , UpdateShaderEvent , MessageEvent , StartSwipeEvent , SwipeEvent , EndSwipeEvent , StartPinchEvent , PinchEvent , EndPinchEvent , StartRotateEvent , RotateEvent , EndRotateEvent , StartPanEvent , PanEvent , EndPanEvent , TapEvent , LongTapEvent , FourthButtonPressEvent , FourthButtonReleaseEvent , FifthButtonPressEvent , FifthButtonReleaseEvent , Move3DEvent , Button3DEvent , TextEvent , LeftButtonDoubleClickEvent , MiddleButtonDoubleClickEvent , RightButtonDoubleClickEvent , MouseWheelLeftEvent , MouseWheelRightEvent , ViewerMovement3DEvent , Menu3DEvent , NextPose3DEvent , Clip3DEvent , PositionProp3DEvent , Pick3DEvent , Select3DEvent , Elevation3DEvent , UserEvent = 1000 }

## Public Member Functions
| vtkBaseTypeMacro (vtkCommand, vtkObjectBase)
void | UnRegister ()
| Decrease the reference count (release by another object). More...
virtual void | Execute (vtkObject *caller, unsigned long eventId, void *callData)=0
| All derived classes of vtkCommand must implement this method. More...
void | SetAbortFlag (vtkTypeBool f)
| Set/Get the abort flag. More...
vtkTypeBool | GetAbortFlag ()
void | AbortFlagOn ()
void | AbortFlagOff ()
void | SetPassiveObserver (vtkTypeBool f)
| Set/Get the passive observer flag. More...
vtkTypeBool | GetPassiveObserver ()
void | PassiveObserverOn ()
void | PassiveObserverOff ()
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual std::string | GetObjectDescription () const
| The object description printed in messages and PrintSelf output. More...
virtual vtkTypeBool | IsA (const char *name)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintSelf (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static bool | EventHasData (unsigned long event)
| Does this event type contain vtkEventData. More...
static const char * | GetStringFromEventId (unsigned long event)
| Convenience methods for translating between event names and event ids. More...
static unsigned long | GetEventIdFromString (const char *event)
| Convenience methods for translating between event names and event ids. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkCommand ()
| ~vtkCommand () override=default
| vtkCommand (const vtkCommand &c)
void | operator= (const vtkCommand &)
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | RegisterInternal (vtkObjectBase *, vtkTypeBool check)
virtual void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check)
virtual void | ReportReferences (vtkGarbageCollector *)
virtual void | ObjectFinalize ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkTypeBool | AbortFlag
vtkTypeBool | PassiveObserver
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Friends
class | vtkSubjectHelper

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

superclass for callback/observer methods

vtkCommand is an implementation of the observer/command design pattern. In this design pattern, any instance of vtkObject can be "observed" for any events it might invoke. For example, vtkRenderer invokes a StartEvent as it begins to render and a EndEvent when it finishes rendering. Filters (subclasses of vtkProcessObject) invoke StartEvent, ProgressEvent, and EndEvent as the filter processes data. Observers of events are added with the AddObserver() method found in vtkObject. AddObserver(), besides requiring an event id or name, also takes an instance of vtkCommand (or a subclasses). Note that vtkCommand is meant to be subclassed, so that you can package the information necessary to support your callback.

Event processing can be organized in priority lists, so it is possible to truncate the processing of a particular event by setting the AbortFlag variable. The priority is set using the AddObserver() method. By default the priority is 0, events of the same priority are processed in last-in-first-processed order. The ordering/aborting of events is important for things like 3D widgets, which handle an event if the widget is selected (and then aborting further processing of that event). Otherwise. the event is passed along for further processing.

When an instance of vtkObject invokes an event, it also passes an optional void pointer to a callData. This callData is nullptr most of the time. The callData is not specific to a type of event but specific to a type of vtkObject invoking a specific event. For instance, vtkCommand::PickEvent is invoked by vtkProp with a nullptr callData but is invoked by vtkInteractorStyleImage with a pointer to the vtkInteractorStyleImage object itself.

Here is the list of events that may be invoked with a non-nullptr callData.

- vtkCommand::ProgressEvent
  - most of the objects return a pointer to a double value ranged between 0.0 and 1.0
  - Infovis/vtkFixedWidthTextReader returns a pointer to a float value equal to the number of lines read so far.
- vtkCommand::ErrorEvent
  - an error message as a const char * string
- vtkCommand::WarningEvent
  - a warning message as a const char * string
- vtkCommand::StartAnimationCueEvent
  - a pointer to a vtkAnimationCue::AnimationCueInfo object
- vtkCommand::EndAnimationCueEvent
  - a pointer to a vtkAnimationCue::AnimationCueInfo object
- vtkCommand::AnimationCueTickEvent
  - a pointer to a vtkAnimationCue::AnimationCueInfo object
- vtkCommand::PickEvent
  - Common/vtkProp returns nullptr
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::StartPickEvent
  - Rendering/vtkPropPicker returns nullptr
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::EndPickEvent
  - Rendering/vtkPropPicker returns nullptr
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::WrongTagEvent
  - Parallel/vtkSocketCommunicator returns a received tag as a char *
- vtkCommand::SelectionChangedEvent
  - Views/vtkView returns nullptr
  - Views/vtkDataRepresentation returns a pointer to a vtkSelection
  - Rendering/vtkInteractorStyleRubberBand2D returns an array of 5 unsigned integers (p1x, p1y, p2x, p2y, mode), where mode is vtkInteractorStyleRubberBand2D::SELECT_UNION or vtkInteractorStyleRubberBand2D::SELECT_NORMAL
- vtkCommand::AnnotationChangedEvent
  - GUISupport/Qt/vtkQtAnnotationView returns a pointer to a vtkAnnotationLayers
- vtkCommand::PlacePointEvent
  - Widgets/vtkSeedWidget returns a pointer to an int, being the current handle number
- vtkCommand::DeletePointEvent
  - Widgets/vtkSeedWidget returns a pointer to an int, being the handle number of the deleted point
- vtkCommand::ResetWindowLevelEvent
  - Widgets/vtkImagePlaneWidget returns an array of 2 double values (window and level)
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::StartWindowLevelEvent
  - Widgets/vtkImagePlaneWidget returns an array of 2 double values (window and level)
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::EndWindowLevelEvent
  - Widgets/vtkImagePlaneWidget returns an array of 2 double values (window and level)
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::WindowLevelEvent
  - Widgets/vtkImagePlaneWidget returns an array of 2 double values (window and level)
  - Rendering/vtkInteractorStyleImage returns a pointer to itself
- vtkCommand::CharEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QKeyEvent *
- vtkCommand::TimerEvent
  - most of the objects return a to an int representing a timer id
  - Widgets/vtkHoverWidget returns nullptr
- vtkCommand::CreateTimerEvent
  - Rendering/vtkGenericRenderWindowInteractor returns a to an int representing a timer id
- vtkCommand::DestroyTimerEvent
  - Rendering/vtkGenericRenderWindowInteractor returns a to an int representing a timer id
- vtkCommand::UserEvent
  - most of the objects return nullptr
  - Infovis/vtkInteractorStyleTreeMapHover returns a pointer to a vtkIdType representing a pedigree id
- vtkCommand::KeyPressEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QKeyEvent*
- vtkCommand::KeyReleaseEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QKeyEvent*
- vtkCommand::LeftButtonPressEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::LeftButtonReleaseEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::MouseMoveEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::MouseWheelForwardEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QWheelEvent*
- vtkCommand::MouseWheelBackwardEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QWheelEvent*
- vtkCommand::RightButtonPressEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::RightButtonReleaseEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::MiddleButtonPressEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::MiddleButtonReleaseEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QMouseEvent*
- vtkCommand::CursorChangedEvent
  - most of the objects return a pointer to an int representing a shape
  - Rendering/vtkInteractorObserver returns nullptr
- vtkCommand::ResetCameraEvent
  - Rendering/vtkRenderer returns a pointer to itself
- vtkCommand::ResetCameraClippingRangeEvent
  - Rendering/vtkRenderer returns a pointer to itself
- vtkCommand::ActiveCameraEvent
  - Rendering/vtkRenderer returns a pointer to the active camera
- vtkCommand::CreateCameraEvent
  - Rendering/vtkRenderer returns a pointer to the created camera
- vtkCommand::EnterEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QEvent*
- vtkCommand::LeaveEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QEvent*
- vtkCommand::RenderWindowMessageEvent
  - Rendering/vtkWin32OpenGLRenderWindow return a pointer to a UINT message
- vtkCommand::ComputeVisiblePropBoundsEvent
  - Rendering/vtkRenderer returns a pointer to itself
- QVTKOpenGLStereoWidget::ContextMenuEvent
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QContextMenuEvent*
- QVTKOpenGLStereoWidget::DragEnterEvent
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QDragEnterEvent*
- QVTKOpenGLStereoWidget::DragMoveEvent
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QDragMoveEvent*
- QVTKOpenGLStereoWidget::DragLeaveEvent
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QDragLeaveEvent*
- QVTKOpenGLStereoWidget::DropEvent
  - GUISupport/Qt/QVTKOpenGLStereoWidget returns a QDropEvent*
- vtkCommand::ViewProgressEvent
  - View/vtkView returns a ViewProgressEventCallData*
- vtkCommand::VolumeMapperRenderProgressEvent
  - A pointer to a double value between 0.0 and 1.0
- vtkCommand::VolumeMapperComputeGradientsProgressEvent
  - A pointer to a double value between 0.0 and 1.0
- vtkCommand::TDxMotionEvent (TDx=3DConnexion)
  - A vtkTDxMotionEventInfo*
- vtkCommand::TDxButtonPressEvent
  - A int* being the number of the button
- vtkCommand::TDxButtonReleaseEvent
  - A int* being the number of the button
- vtkCommand::UpdateShaderEvent
  - A vtkOpenGLHelper* currently being used
- vtkCommand::FourthButtonPressEvent
  - most of the objects return nullptr
- vtkCommand::FourthButtonReleaseEvent
  - most of the objects return nullptr
- vtkCommand::FifthButtonPressEvent
  - most of the objects return nullptr
- vtkCommand::FifthButtonReleaseEvent
  - most of the objects return nullptr
- vtkCommand::MouseWheelLeftEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLWidget returns a QWheelEvent*
- vtkCommand::MouseWheelRightEvent
  - most of the objects return nullptr
  - GUISupport/Qt/QVTKOpenGLWidget returns a QWheelEvent*
- vtkCommand::ErrorEvent
  - vtkOutputWindow fires this with `char char*` for the error message
- vtkCommand::WarningEvent
  - vtkOutputWindow fires this with `char char*` for the warning message
- vtkCommand::MessageEvent
  - vtkOutputWindow fires this with `char char*` for the message text
- vtkCommand::TextEvent
  - vtkOutputWindow fires this with `char char*` for the text

See also
  vtkObject vtkCallbackCommand vtkOldStyleCallbackCommand vtkInteractorObserver vtk3DWidget

Definition at line 383 of file vtkCommand.h.

## Member Enumeration Documentation

## ◆ EventIds

enum vtkCommand::EventIds

Enumerator
NoEvent |
AnyEvent |
DeleteEvent |
StartEvent |
EndEvent |
RenderEvent |
ProgressEvent |
PickEvent |
StartPickEvent |
EndPickEvent |
AbortCheckEvent |
ExitEvent |
LeftButtonPressEvent |
LeftButtonReleaseEvent |
MiddleButtonPressEvent |
MiddleButtonReleaseEvent |
RightButtonPressEvent |
RightButtonReleaseEvent |
EnterEvent |
LeaveEvent |
KeyPressEvent |
KeyReleaseEvent |
CharEvent |
ExposeEvent |
ConfigureEvent |
TimerEvent |
MouseMoveEvent |
MouseWheelForwardEvent |
MouseWheelBackwardEvent |
ActiveCameraEvent |
CreateCameraEvent |
ResetCameraEvent |
ResetCameraClippingRangeEvent |
ModifiedEvent |
WindowLevelEvent |
StartWindowLevelEvent |
EndWindowLevelEvent |
ResetWindowLevelEvent |
SetOutputEvent |
ErrorEvent |
WarningEvent |
StartInteractionEvent |
DropFilesEvent |
UpdateDropLocationEvent |
InteractionEvent |
EndInteractionEvent |
EnableEvent |
DisableEvent |
CreateTimerEvent |
DestroyTimerEvent |
PlacePointEvent |
DeletePointEvent |
PlaceWidgetEvent |
CursorChangedEvent |
ExecuteInformationEvent |
RenderWindowMessageEvent |
WrongTagEvent |
StartAnimationCueEvent |
ResliceAxesChangedEvent |
AnimationCueTickEvent |
EndAnimationCueEvent |
VolumeMapperRenderEndEvent |
VolumeMapperRenderProgressEvent |
VolumeMapperRenderStartEvent |
VolumeMapperComputeGradientsEndEvent |
VolumeMapperComputeGradientsProgressEvent |
VolumeMapperComputeGradientsStartEvent |
WidgetModifiedEvent |
WidgetValueChangedEvent |
WidgetActivateEvent |
ConnectionCreatedEvent |
ConnectionClosedEvent |
DomainModifiedEvent |
PropertyModifiedEvent |
UpdateEvent |
RegisterEvent |
UnRegisterEvent |
UpdateInformationEvent |
AnnotationChangedEvent |
SelectionChangedEvent |
UpdatePropertyEvent |
ViewProgressEvent |
UpdateDataEvent |
CurrentChangedEvent |
ComputeVisiblePropBoundsEvent |
TDxMotionEvent |
TDxButtonPressEvent |
TDxButtonReleaseEvent |
HoverEvent |
LoadStateEvent |
SaveStateEvent |
StateChangedEvent |
WindowMakeCurrentEvent |
WindowIsCurrentEvent |
WindowFrameEvent |
HighlightEvent |
WindowSupportsOpenGLEvent |
WindowIsDirectEvent |
WindowStereoTypeChangedEvent |
WindowResizeEvent |
UncheckedPropertyModifiedEvent |
UpdateShaderEvent |
MessageEvent |
StartSwipeEvent |
SwipeEvent |
EndSwipeEvent |
StartPinchEvent |
PinchEvent |
EndPinchEvent |
StartRotateEvent |
RotateEvent |
EndRotateEvent |
StartPanEvent |
PanEvent |
EndPanEvent |
TapEvent |
LongTapEvent |
FourthButtonPressEvent |
FourthButtonReleaseEvent |
FifthButtonPressEvent |
FifthButtonReleaseEvent |
Move3DEvent |
Button3DEvent |
TextEvent |
LeftButtonDoubleClickEvent |
MiddleButtonDoubleClickEvent |
RightButtonDoubleClickEvent |
MouseWheelLeftEvent |
MouseWheelRightEvent |
ViewerMovement3DEvent |
Menu3DEvent |
NextPose3DEvent |
Clip3DEvent |
PositionProp3DEvent |
Pick3DEvent |
Select3DEvent |
Elevation3DEvent |
UserEvent |

Definition at line 451 of file vtkCommand.h.

## Constructor & Destructor Documentation

## ◆ vtkCommand() [1/2]

vtkCommand::vtkCommand | ( |  | ) |
| protected

## ◆ ~vtkCommand()

vtkCommand::~vtkCommand | ( |  | ) |
| overrideprotecteddefault

## ◆ vtkCommand() [2/2]

vtkCommand::vtkCommand | ( | const vtkCommand & | c | ) |
| inlineprotected

Definition at line 463 of file vtkCommand.h.

## Member Function Documentation

## ◆ vtkBaseTypeMacro()

vtkCommand::vtkBaseTypeMacro | ( | vtkCommand | ,
|  | vtkObjectBase |
| ) |  |

## ◆ UnRegister()

void vtkCommand::UnRegister | ( |  | ) |

Decrease the reference count (release by another object).

This has the same effect as invoking Delete() (i.e., it reduces the reference count by 1).

## ◆ Execute()

virtual void vtkCommand::Execute | ( | vtkObject * | caller,
|  | unsigned long | eventId,
|  | void * | callData
| ) |  |
| pure virtual

All derived classes of vtkCommand must implement this method.

This is the method that actually does the work of the callback. The caller argument is the object invoking the event, the eventId parameter is the id of the event, and callData parameter is data that can be passed into the execute method. (Note: vtkObject::InvokeEvent() takes two parameters: the event id (or name) and call data. Typically call data is nullptr, but the user can package data and pass it this way. Alternatively, a derived class of vtkCommand can be used to pass data.)

Implemented in vtkOldStyleCallbackCommand, vtkEventForwarderCommand, vtkCallbackCommand, and vtkTclCommand.

## ◆ GetStringFromEventId()

static const char* vtkCommand::GetStringFromEventId | ( | unsigned long | event | ) |
| static

Convenience methods for translating between event names and event ids.

## ◆ GetEventIdFromString()

static unsigned long vtkCommand::GetEventIdFromString | ( | const char * | event | ) |
| static

Convenience methods for translating between event names and event ids.

## ◆ EventHasData()

static bool vtkCommand::EventHasData | ( | unsigned long | event | ) |
| static

Does this event type contain vtkEventData.

## ◆ SetAbortFlag()

void vtkCommand::SetAbortFlag | ( | vtkTypeBool | f | ) |
| inline

Set/Get the abort flag.

If this is set to true no further commands are executed.

Definition at line 428 of file vtkCommand.h.

## ◆ GetAbortFlag()

vtkTypeBool vtkCommand::GetAbortFlag | ( |  | ) |
| inline

Definition at line 429 of file vtkCommand.h.

## ◆ AbortFlagOn()

void vtkCommand::AbortFlagOn | ( |  | ) |
| inline

Definition at line 430 of file vtkCommand.h.

## ◆ AbortFlagOff()

void vtkCommand::AbortFlagOff | ( |  | ) |
| inline

Definition at line 431 of file vtkCommand.h.

## ◆ SetPassiveObserver()

void vtkCommand::SetPassiveObserver | ( | vtkTypeBool | f | ) |
| inline

Set/Get the passive observer flag.

If this is set to true, this indicates that this command does not change the state of the system in any way. Passive observers are processed first, and are not called even when another command has focus.

Definition at line 439 of file vtkCommand.h.

## ◆ GetPassiveObserver()

vtkTypeBool vtkCommand::GetPassiveObserver | ( |  | ) |
| inline

Definition at line 440 of file vtkCommand.h.

## ◆ PassiveObserverOn()

void vtkCommand::PassiveObserverOn | ( |  | ) |
| inline

Definition at line 441 of file vtkCommand.h.

## ◆ PassiveObserverOff()

void vtkCommand::PassiveObserverOff | ( |  | ) |
| inline

Definition at line 442 of file vtkCommand.h.

## ◆ operator=()

void vtkCommand::operator= | ( | const vtkCommand & |  | ) |
| inlineprotected

Definition at line 467 of file vtkCommand.h.

## Friends And Related Function Documentation

## ◆ vtkSubjectHelper

friend class vtkSubjectHelper
| friend

Definition at line 461 of file vtkCommand.h.

## Member Data Documentation

## ◆ AbortFlag

vtkTypeBool vtkCommand::AbortFlag
| protected

Definition at line 455 of file vtkCommand.h.

## ◆ PassiveObserver

vtkTypeBool vtkCommand::PassiveObserver
| protected

Definition at line 456 of file vtkCommand.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkCommand.h